area = {}

local ticks_since_action = 0

function area.create(position,dx,dy)
	if not dy then dy = dx end
	return {{position.x - dx, position.y - dy},{position.x + dx, position.y + dy}}
end

function copy_car(index,car)

			if not car or not global.cars[index] then
				return
			end
	
			-- GET THIS CAR TRUNK INVENTORY
		   local copy_this_trunk = car.get_inventory(defines.inventory.car_trunk);
		   
		   if copy_this_trunk then
		   		   local contents = copy_this_trunk.get_contents()
				   for item, amount in pairs(contents) do
					   if isBlank(item) == nil then 
					   
					   else
							global.cars[index].get_inventory(defines.inventory.car_trunk).insert{name = item, count = amount}
					   end
				   end
			end

		   	-- GET THIS CAR FUEL INVENTORY
		   local copy_this_fuel = car.get_inventory(defines.inventory.fuel);
		   
		   if  copy_this_fuel then 
					   local contents = copy_this_fuel.get_contents()
			   for item, amount in pairs(contents) do
				   if isBlank(item) == nil then 
				   
				   else
						global.cars[index].get_inventory(defines.inventory.fuel).insert{name = item, count = amount}
				   end
			   end
		   end

		   -- GET THIS CAR AMMO INVENTORY
		   local copy_this_ammo = car.get_inventory(defines.inventory.car_ammo);
		   
		   if  copy_this_ammo then
		   
			local contents = copy_this_ammo.get_contents()
			   for item, amount in pairs(contents) do
				   if isBlank(item) == nil then 
				   
				   else
						global.cars[index].get_inventory(defines.inventory.car_ammo).insert{name = item, count = amount}
				   end
			   end
		   
		   end
end



script.on_event(defines.events.on_built_entity, function(event)

	local index = event.player_index
	local player = game.players[event.player_index]
	local entity = event.created_entity

	-- KEY WAS USED
	if entity.name == "car-key" then
	
		if ticks_since_action < 60 then
			entity.destroy()
			player.cursor_stack.set_stack{name = "car-key", count = 1}
			return	
		end
		
		ticks_since_action = 0
	
		if not player.cursor_stack.valid_for_read then 
			player.cursor_stack.set_stack{name = "car-key", count = 1}
		elseif player.cursor_stack.name == "car-key" then
			player.cursor_stack.count = player.cursor_stack.count + 1
		elseif player.insert({name = "car-key", count = 1}) == 0 then
			player.surface.spill_item_stack(player.position,{name = "car-key", count = 1})
		end
		
		-- GET the location the key was used and find any cars in range
		local car = nil
		local cars = entity.surface.find_entities_filtered{area = area.create(entity.position,1), type = "car"}
		
		-- loop through all the objects we found and find the first car
		for i in pairs(cars) do
		 local find_car = cars[i]
			if find_car.type == "car" then
				local wordIsThere = string.find(tostring(find_car.name), "turret")
				if wordIsThere then
				-- Dont save turrets
				else
					car = find_car
					break
				end
			end	
		end
		
		
		-- Found car
		if car then
			-- Do we own this car
			local carOwned = false
			--game.write_file("mymod_logoutput.txt", "\n", true)
			-- Player tried to take your car
			for player_index,car2 in pairs(global.cars) do
				if car == car2 and player_index ~= index then
					player.print("This car is owned by "..game.players[player_index].name)
					game.players[player_index].print(player.name.." has tried to take your car!")
					carOwned = true
				end
			end
			
			-- You own this car, lock or unlock the doors
			if not carOwned and global.cars[index] == car then
				 car.operable = not car.operable
				 car.active = car.operable
				 car.minable = car.operable
				 local locked = "locked"
				 if car.operable then locked = "unlocked" end
				 player.print("Your car is now "..locked)
			else
				--Car not owned, this is your new car
				
					if car.type == "car" then
						local wordIsThere = string.find(tostring(car.name), "turret")
						if wordIsThere then
						-- Dont save turrets
						else
						global.cars[index] = car
						player.print("This is now your car")
						end
					end

			end			
			
		elseif global.cars[index].valid then
					--Get current car
			local car = global.cars[index]
		
			if car.type == "car" then
				-- Copy current car and create a new car on map
				local new_car = entity.surface.create_entity{name = car.name, position = entity.position, force = player.force, direction = car.direction}
				new_car.health = car.health
				global.cars[index] = new_car
				-- Set new car settings equal to the old cars settings, including inventory
				copy_car(index,car)
				--Destroy old car now that we have the new clone ready
				car.destroy()
				-- Make a sound at location
				global.surface[index] = entity.surface
				global.position[index] = entity.position
				--global.surface[index].create_entity{name = "Dude_sound", position = global.position[index]}
				player.print("Your car has arrived!")
				else
					player.print("Invalid Car Type, Try selecting a new car.")
			end
		
		else
			player.print("You don't own a car, you can claim a car by clicking these keys on a car (or tank)")
		end
		entity.destroy()
	end
end)


function isBlank(x)
  return not not tostring(x):find("^%s*$")
end

function init()
	ticks_since_action = 0
	global.cars = global.cars or {}
	global.surface = global.surface or {}
	global.position = global.position or {}	
end

function init_player(player)
	global.cars[player.index] = global.cars[player.index] or {}
	log("[DWMC] Initialised player ["..player.index.."]"..player.name)
end

script.on_event(defines.events.on_tick, function(event)
	ticks_since_action = ticks_since_action + 1
end)

script.on_init(function(event)
	init()
end)

script.on_event(defines.events.on_player_created, function(event)
	local player = game.players[event.player_index]
	init_player(player)
end)

script.on_configuration_changed(function(event)
	init()
	for _,player in pairs(game.players) do
		init_player(player)
	end
end)


script.on_event(defines.events.on_pre_player_mined_item, function(event)
	if event.entity.type == "car" then
		for index,car in pairs(global.cars) do
			if event.entity == car then
				global.cars[index] = {}
				if index == event.player_index then
					game.players[index].print("You no longer own a car, use your keys to claim a new one")
				else
					game.players[index].print(game.players[event.player_index].name.." mined your car, use your keys to claim a new one")
				end
			end
		end
	elseif event.entity.type == "unit" then
		for index,car in pairs(global.cars) do
			if not car.valid and event.entity == car.kitt then
				global.cars[index] = {}
				global.surface[index] = nil
				global.position[index] = nil
				if index == event.player_index then
					game.players[index].print("You no longer own a car, use your keys to claim a new one")
				else
					game.players[index].print(game.players[event.player_index].name.." mined your car, use your keys to claim a new one")
				end
			end
		end
	end
end)

script.on_event(defines.events.on_robot_pre_mined, function(event)
	if event.entity.type == "car" then
		for index,car in pairs(global.cars) do
			if event.entity == car then
				global.cars[index] = {}
				game.players[index].print("Robots mined your car, use your keys to claim a new one")
			end
		end
	elseif event.entity.type == "unit" then
		for index,car in pairs(global.cars) do
			if not car.valid and event.entity == car.kitt then
				global.cars[index] = {}
				global.surface[index] = nil
				global.position[index] = nil
				game.players[index].print("Robots mined your car, use your keys to claim a new one")
			end
		end
	end
end)

script.on_event(defines.events.on_entity_died, function(event)
	if event.entity.type == "car" then
		for index,car in pairs(global.cars) do
			if event.entity == car then
				global.cars[index] = {}
				game.players[index].print("Your car is destroyed, use your keys to claim a new one")
			end
		end
	end
end)